unit Unit1;
{
  Description:
  Shows how to use and API called SetwindowPlacement to
  show state and the restored, minimized, and maximized positions of
  the specified window. Refer to GetWindowPlacement example also.

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls,StdCtrls, Unit2, ExtCtrls;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    chkMinimize: TCheckBox;
    chkMaximize: TCheckBox;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetChildInfo ;
    procedure SetChildInfo ;
  end;

var
  Form1: TForm1;
  f:TForm2 ;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  f := TForm2.Create(nil);
  try
    f.show ;
    f.UpDate ;
    Button1.Enabled := False ;
    Button2.Enabled := True ;
  except
  end;
end;

{
  Shows how to work with records by retrieving information
  for a form using Windows API call GetWindowPlacement.
}
procedure TForm1.GetChildInfo;
var
  WindowPlacement: TWindowPlacement ;
  TargetWnd: HWND ;
begin

  TargetWnd := FindWindow('TForm2',nil) ;

  if TargetWnd <> 0 then
  begin
    WindowPlacement.Length := SizeOf(WindowPlacement) ;
    GetWindowPlacement(TargetWnd, @WindowPlacement) ;
    with WindowPlacement.rcNormalPosition do
      with F.Label1 do
        Caption := Format('Left: %d, Top: %d, Right: %d, Bottom: %d',
          [Left, Top, Right, Bottom]) ;
  end;
end;

procedure TForm1.SetChildInfo;
var
  MyRec:TWindowPlacement ;
  TargetWnd: HWND ;
begin

  TargetWnd := FindWindow('TForm2',nil) ;

  if TargetWnd <> 0 then
  begin
    MyRec.Length := SizeOf(MyRec) ;
    if not GetWindowPlacement(TargetWnd, @MyRec) then
      ShowMessage('GetWindowPlacement Failed') ;

    with MyRec do begin
      Length := MyRec.length ;
      if chkMinimize.Checked then
        Flags := WPF_SETMINPOSITION ;

      { This is purely a random location }
      if chkMaximize.Checked then
        ptMinPosition := Point(10,10) ;

      { The maximized form is not desirable but shows
        what can be done. Also a random location }
      if chkMaximize.Checked then
        ptMaxPosition := Point(0,300)
      else
        ptMaxPosition := Point(0,0) ;

      with MyRec.rcNormalPosition do
      begin
        Left := Left + 10 ;
        Top := Top + 100 ;
        Bottom := Bottom + 110 ;
      end ;

      { Minimize the form }
      if chkMinimize.Checked then
        ShowCmd := SW_MINIMIZE ;
    end ;
    { Use SetWindowPlacement to set our new coordinates }
    if not SetwindowPlacement(TargetWnd, @MyRec) then
      ShowMessage('SetwindowPlacement Failed') ;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SetChildInfo ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button2.Enabled := False ;
end;

end.
