unit Unit1;

{ Description:
  The demo shows how to use an API called "GetWindowPlacement" which  retrieves
  various pieces of data concerning a windows position and current state of
  "minimized/maximized etc."

  Also shows a simple use for WM_MOVE in the child form }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls,StdCtrls, Unit2;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetChildInfo ;
  end;

var
  Form1: TForm1;
  f:TForm2 ;


implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  f := TForm2.Create(nil) ;
  try
    f.show ;
    f.UpDate ;
    Button1.Enabled := False ;
  except
    { Form is closed within itself i.e. Action := caFree }
  end ;
end;

procedure TForm1.GetChildInfo;
  function IsMinimizedForm2( WinHandle : HWND ) : boolean ;
  begin
    Result := IsIconic( WinHandle ) ;
  end ;
var
  WindowPlacement: TWindowPlacement ;
  TargetWnd: HWND ;
begin
  { Find out if the window/form has been created and available }
  TargetWnd := FindWindow('TForm2',nil) ;
  if TargetWnd <> 0 then
  begin
    { We need to initialize the structure TWindowPlacement before using it }
    WindowPlacement.Length := SizeOf(WindowPlacement);
    { This call fills the members of TWindowPlacement }
    GetWindowPlacement(TargetWnd, @WindowPlacement) ;
    with WindowPlacement.rcNormalPosition do
      F.Label1.Caption := Format('Left: %d, Top: %d, Right: %d, Bottom: %d',
        [Left, Top, Right, Bottom]) ;

    { If the window is not minimized negative numbers return so check
      to see if the window is minimized for this purpose. Hide the label
      otherwise. }
    if IsMinimizedForm2(TargetWnd) then
    begin
      with WindowPlacement.ptMinPosition do
        Label2.Caption := Format('x: %d, y: %d',[x,y]) ;
      Label2.Visible := True ;
    end else
      Label2.Visible := False ;
  end ;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { I like this rather then doing it via the Object Inspector }
  Label2.Visible := False ;
end;

end.
